Home | History | Annotate | Download | only in buildit
      1 #!/bin/sh
      2 # LLVM LOCAL file B&I
      3 
      4 set -x
      5 
      6 # Build LLVM the "Apple way".
      7 # Parameters:
      8 
      9 # The first parameter is a space-separated list of the architectures the
     10 # compilers will run on. For instance, "ppc i386". If the current machine
     11 # isn't in the list, it will (effectively) be added.
     12 HOSTS="$1"
     13 
     14 # The second parameter is a space-separated list of the architectures the
     15 # compilers will generate code for. If the current machine isn't in the list, a
     16 # compiler for it will get built anyway, but won't be installed.
     17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
     18 TARGETS="$2"
     19 
     20 # The third parameter is the path to the compiler sources. There should be a
     21 # shell script named 'configure' in this directory. This script makes a copy...
     22 ORIG_SRC_DIR="$3"
     23 
     24 # The fourth parameter is the location where the LLVM will be installed. You can
     25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
     26 DEST_ROOT="$4"
     27 
     28 # The fifth parameter is the place where the compiler will be copied once it's
     29 # built.
     30 DEST_DIR="$5"
     31 
     32 # The sixth parameter is a directory in which to place information (like
     33 # unstripped executables and generated source files) helpful in debugging the
     34 # resulting compiler.
     35 SYM_DIR="$6"
     36 
     37 # The seventh parameter is a yes/no that indicates whether assertions should be
     38 # enabled in the LLVM libs/tools.
     39 LLVM_ASSERTIONS="$7"
     40 
     41 # The eighth parameter is a yes/no that indicates whether this is an optimized
     42 # build.
     43 LLVM_OPTIMIZED="$8"
     44 
     45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
     46 # should be installed.
     47 INSTALL_LIBLTO="$9"
     48 
     49 # A yes/no parameter that controls whether to cross-build for an ARM host.
     50 ARM_HOSTED_BUILD="${10}"
     51 
     52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
     53 IOS_SIM_BUILD="${11}"
     54 
     55 # The version number of the submission, e.g. 1007.
     56 LLVM_SUBMIT_VERSION="${12}"
     57 
     58 # The subversion number of the submission, e.g. 03.
     59 LLVM_SUBMIT_SUBVERSION="${13}"
     60 
     61 # The current working directory is where the build will happen. It may already
     62 # contain a partial result of an interrupted build, in which case this script
     63 # will continue where it left off.
     64 DIR=`pwd`
     65 
     66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
     67 echo DARWIN_VERS = $DARWIN_VERS
     68 
     69 ################################################################################
     70 # Run the build.
     71 
     72 # Create the source tree we'll actually use to build, deleting
     73 # tcl since it doesn't actually build properly in a cross environment
     74 # and we don't really need it.
     75 SRC_DIR=$DIR/src
     76 rm -rf $SRC_DIR || exit 1
     77 mkdir $SRC_DIR || exit 1
     78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
     79 # We can't use the top-level Makefile as-is.  Remove the soft link:
     80 rm $SRC_DIR/Makefile || exit 1
     81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
     82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
     83 
     84 # Build the LLVM tree universal.
     85 mkdir -p $DIR/obj-llvm || exit 1
     86 cd $DIR/obj-llvm || exit 1
     87 
     88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
     89   # The cross-tools' build process expects to find an existing cross toolchain
     90   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
     91   rm -rf $DIR/bin || exit 1
     92   mkdir $DIR/bin || exit 1
     93   for prog in ar nm ranlib strip lipo ld as ; do
     94     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
     95     T=`xcrun -sdk $SDKROOT -find ${prog}`
     96     echo '#!/bin/sh' > $P || exit 1
     97     echo 'exec '$T' "$@"' >> $P || exit 1
     98     chmod a+x $P || exit 1
     99   done
    100   # Set up the links for clang.
    101   for prog in clang clang++ ; do
    102     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
    103     T=`xcrun -sdk $SDKROOT -find ${prog}`
    104     echo '#!/bin/sh' > $P || exit 1
    105     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
    106     chmod a+x $P || exit 1
    107   done
    108 
    109   PATH=$DIR/bin:$PATH
    110 fi
    111 
    112 if [ "$ARM_HOSTED_BUILD" = yes ]; then
    113   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
    114                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
    115 elif [ "$IOS_SIM_BUILD" = yes ]; then
    116   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
    117   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
    118                   --build=i686-apple-darwin10"
    119 else
    120   configure_opts="--enable-targets=arm,x86,cbe"
    121 fi
    122 
    123 if [ \! -f Makefile.config ]; then
    124   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
    125     --enable-assertions=$LLVM_ASSERTIONS \
    126     --enable-optimized=$LLVM_OPTIMIZED \
    127     --disable-bindings \
    128     || exit 1
    129 fi
    130 
    131 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
    132 
    133 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
    134     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
    135     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
    136     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
    137 fi
    138 
    139 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
    140     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
    141 else
    142     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
    143 fi
    144 
    145 # Figure out how many make processes to run.
    146 SYSCTL=`sysctl -n hw.activecpu`
    147 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
    148 # Builders can default to 2, since even if they are single processor,
    149 # nothing else is running on the machine.
    150 if [ -z "$SYSCTL" ]; then
    151     SYSCTL=2
    152 fi
    153 JOBS_FLAG="-j $SYSCTL"
    154 
    155 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
    156     UNIVERSAL_SDK_PATH=$SDKROOT \
    157     NO_RUNTIME_LIBS=1 \
    158     DISABLE_EDIS=1 \
    159     DEBUG_SYMBOLS=1 \
    160     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
    161     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
    162     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
    163     VERBOSE=1
    164 
    165 if [ $? != 0 ] ; then
    166     echo "error: LLVM 'make' failed!"
    167     exit 1
    168 fi 
    169 
    170 ################################################################################
    171 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
    172 # $DEST_DIR, with occasional 'lipo' commands.
    173 
    174 cd $DEST_DIR || exit 1
    175 
    176 # Clean out DEST_DIR in case -noclean was passed to buildit.
    177 rm -rf * || exit 1
    178 
    179 cd $DIR/obj-llvm || exit 1
    180 
    181 # Install the tree into the destination directory.
    182 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
    183     NO_RUNTIME_LIBS=1 \
    184     DISABLE_EDIS=1 \
    185     DEBUG_SYMBOLS=1 \
    186     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
    187     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
    188     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
    189 
    190 if ! test $? == 0 ; then
    191     echo "error: LLVM 'make install' failed!"
    192     exit 1
    193 fi 
    194 
    195 # Install Version.h
    196 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
    197 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
    198     LLVM_MINOR_VERSION=0
    199 fi
    200 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
    201 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
    202 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
    203 
    204 # Find the right version of strip to use.
    205 STRIP=strip
    206 if [ -n "$SDKROOT" ]; then
    207   STRIP=`xcrun -sdk $SDKROOT -find strip`
    208 fi
    209 
    210 if [ "x$LLVM_DEBUG" != "x1" ]; then
    211     # Strip local symbols from llvm libraries.
    212     #
    213     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    214     # PPC objects!
    215     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
    216     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
    217         $STRIP -Sxl $f
    218     done
    219 fi
    220 
    221 # Copy over the tblgen utility.
    222 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
    223 
    224 # Remove .dir files 
    225 cd $DEST_DIR$DEST_ROOT
    226 rm -f bin/.dir etc/llvm/.dir lib/.dir
    227 
    228 # Remove PPC64 fat slices.
    229 cd $DEST_DIR$DEST_ROOT/bin
    230 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
    231     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
    232         -exec lipo -extract ppc -extract i386 {} -output {} \;
    233 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
    234     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
    235         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
    236 else
    237     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
    238         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
    239 fi
    240 
    241 # The Hello dylib is an example of how to build a pass.
    242 # The BugpointPasses module is only used to test bugpoint.
    243 # These unversioned dylibs cause verification failures, so do not install them.
    244 # (The wildcards are used to match a "lib" prefix if it is present.)
    245 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
    246 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
    247 
    248 # Compress manpages
    249 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
    250 gzip -f $MDIR/*
    251 
    252 ################################################################################
    253 # Create SYM_DIR with information required for debugging.
    254 
    255 # Figure out how many make processes to run.
    256 SYSCTL=`sysctl -n hw.activecpu`
    257 
    258 # hw.activecpu only available in 10.2.6 and later
    259 if [ -z "$SYSCTL" ]; then
    260   SYSCTL=`sysctl -n hw.ncpu`
    261 fi
    262 
    263 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
    264 # can default to 2, since even if they are single processor, nothing else is
    265 # running on the machine.
    266 if [ -z "$SYSCTL" ]; then
    267   SYSCTL=2
    268 fi
    269 
    270 cd $SYM_DIR || exit 1
    271 
    272 # Clean out SYM_DIR in case -noclean was passed to buildit.
    273 rm -rf * || exit 1
    274 
    275 # Generate .dSYM files
    276 find $DEST_DIR -perm -0111 -type f \
    277     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
    278     -print | xargs -n 1 -P ${SYSCTL} dsymutil
    279 
    280 # Save .dSYM files and .a archives
    281 cd $DEST_DIR || exit 1
    282 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
    283     | cpio -pdml $SYM_DIR || exit 1
    284 
    285 # Save source files.
    286 mkdir $SYM_DIR/src || exit 1
    287 cd $DIR || exit 1
    288 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
    289     | cpio -pdml $SYM_DIR/src || exit 1
    290 
    291 ################################################################################
    292 # Install and strip libLTO.dylib
    293 
    294 cd $DEST_DIR$DEST_ROOT
    295 if [ "$INSTALL_LIBLTO" = "yes" ]; then
    296   DT_HOME="$DEST_DIR/Developer/usr"
    297   mkdir -p $DT_HOME/lib
    298   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
    299 
    300   # Save a copy of the unstripped dylib
    301   mkdir -p $SYM_DIR/Developer/usr/lib
    302   cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
    303 
    304   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    305   # PPC objects!
    306   $STRIP -arch all -Sl $DT_HOME/lib/libLTO.dylib
    307 
    308   if [ "x$DISABLE_USR_LINKS" == "x" ]; then
    309     # Add a symlink in /usr/lib for B&I.
    310     mkdir -p $DEST_DIR/usr/lib/
    311     (cd $DEST_DIR/usr/lib && \
    312       ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
    313   fi
    314 else
    315   rm -f lib/libLTO.dylib
    316 fi
    317 rm -f lib/libLTO.a lib/libLTO.la
    318 
    319 # Omit lto.h from the result.  Clang will supply.
    320 find $DEST_DIR$DEST_ROOT -name lto.h -delete
    321 
    322 ################################################################################
    323 # Remove debugging information from DEST_DIR.
    324 
    325 cd $DIR || exit 1
    326 
    327 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
    328 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
    329 
    330 # Strip debugging information from files
    331 #
    332 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    333 # PPC objects!
    334 find $DEST_DIR -perm -0111 -type f \
    335     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
    336     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
    337 
    338 chgrp -h -R wheel $DEST_DIR
    339 chgrp -R wheel $DEST_DIR
    340 
    341 ################################################################################
    342 # Remove the docs directory
    343 
    344 rm -rf $DEST_DIR$DEST_ROOT/docs
    345 
    346 ################################################################################
    347 # w00t! Done!
    348 
    349 exit 0
    350